Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7067)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7068)
@@ -98,10 +98,15 @@
        CHARACTER(len = 20)  :: clunit   !: unit
        LOGICAL              :: llinit   !: read in a file or not
-#if defined  key_my_trc
        LOGICAL              :: llsbc   !: read in a file or not
        LOGICAL              :: llcbc   !: read in a file or not
        LOGICAL              :: llobc   !: read in a file or not
-#endif
    END TYPE PTRACER
+
+   TYPE, PUBLIC :: STRACER                                                            !: Passive tracer type
+       LOGICAL              :: llsbc   !: read in a file or not
+       LOGICAL              :: llcbc   !: read in a file or not
+       LOGICAL              :: llobc   !: read in a file or not
+   END TYPE STRACER
+
    CHARACTER(len = 20), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ctrcnm         !: tracer name 
    CHARACTER(len = 80), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ctrcln         !: trccer field long name
@@ -116,8 +121,8 @@
    !! information for inputs
    !! --------------------------------------------------
-   LOGICAL            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_ini     !: Initialisation from data input file
-   LOGICAL            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_obc     !: Use open boundary condition data
-   LOGICAL            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_sbc     !: Use surface boundary condition data
-   LOGICAL            , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_cbc     !: Use coastal boundary condition data
+   LOGICAL   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_ini     !: Initialisation from data input file
+   LOGICAL   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_obc     !: Use open boundary condition data
+   LOGICAL   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_sbc     !: Use surface boundary condition data
+   LOGICAL   , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)    ::  ln_trc_cbc     !: Use coastal boundary condition data
 
 
@@ -199,14 +204,4 @@
          &      sbc_trc_b(jpi,jpj,jptra), sbc_trc(jpi,jpj,jptra)                      ,       &  
          &      cvol(jpi,jpj,jpk)     , trai(jptra)           ,  qsr_mean(jpi,jpj)    ,       &
-         &      ctrcnm(jptra)         , ctrcln(jptra)         , ctrcun(jptra)         ,       & 
-         &      ln_trc_ini(jptra)     ,                                                       &
-         &      trc_ice_ratio(jptra)  , trc_ice_prescr(jptra) , cn_trc_o(jptra)       ,       & 
-#if defined key_my_trc
-         &      ln_trc_sbc(jptra)     , ln_trc_cbc(jptra)     , ln_trc_obc(jptra)     ,       &
-#endif
-#if defined key_bdy
-         &      cn_trc_dflt(nb_bdy)   , cn_trc(nb_bdy)        , nn_trcdmp_bdy(nb_bdy) ,       &
-         &      trcdta_bdy(jptra,nb_bdy)                                              ,       &
-#endif
          &      STAT = trc_alloc  )
 
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcice.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcice.F90	(revision 7067)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcice.F90	(revision 7068)
@@ -52,9 +52,9 @@
 
       IF ( nn_ice_tr == 1 ) THEN
-         IF( lk_pisces  )    CALL trc_ice_ini_pisces       ! PISCES  bio-model
+         IF( ln_pisces  )    CALL trc_ice_ini_pisces       ! PISCES  bio-model
          IF( ll_cfc     )    CALL trc_ice_ini_cfc          ! CFC     tracers
          IF( ln_c14     )    CALL trc_ice_ini_c14          ! C14     tracer
          IF( ln_age     )    CALL trc_ice_ini_age          ! AGE     tracer
-         IF( lk_my_trc  )    CALL trc_ice_ini_my_trc       ! MY_TRC  tracers
+         IF( ln_my_trc  )    CALL trc_ice_ini_my_trc       ! MY_TRC  tracers
       ENDIF
 
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7067)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7068)
@@ -59,10 +59,9 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~'
 
-      IF( .NOT.lk_offline )   CALL trc_nam_run     ! Parameters of the run 
-      !
-      CALL top_alloc()   ! allocate TOP arrays
+      !
       !
       CALL trc_ini_ctl   ! control 
       CALL trc_nam       ! read passive tracers namelists
+      CALL top_alloc()   ! allocate TOP arrays
       !
       !
@@ -152,5 +151,4 @@
       !! ** Purpose :   SMS initialisation
       !!----------------------------------------------------------------------
-      USE par_trc
       USE trcini_pisces  ! PISCES   initialisation
       USE trcini_cfc     ! CFC      initialisation
@@ -159,49 +157,10 @@
       USE trcini_my_trc  ! MY_TRC   initialisation
       !!----------------------------------------------------------------------
-      jp_lc = 0
-      IF( lk_pisces  )  THEN       ! PISCES bio-model
-         CALL trc_ini_pisces    
-         jp_lc       = jp_pisces 
-      ELSE
-         jp_pisces   = 0
-         jp_pcs0     = 0              
-         jp_pcs1     = 0         
-      ENDIF
-      IF( lk_my_trc )  THEN      ! MY_TRC
-         CALL trc_ini_my_trc
-         jp_lc       = jp_lc + jp_my_trc  
-      ELSE
-         jp_my_trc   = 0
-         jp_myt0     = 0       
-         jp_myt1     = 0      
-      ENDIF
-      IF( ll_cfc    )  THEN          ! CFC
-         CALL trc_ini_cfc    
-         jp_lc       = jp_lc + jp_cfc
-      ELSE
-         jp_cfc      = 0
-         jp_cfc0     = 0       
-         jp_cfc1     = 0      
-      ENDIF
-      IF( ln_c14    )  THEN      ! C14
-         CALL trc_ini_c14
-         jp_lc       = jp_lc + jp_c14
-      ELSE
-         jp_c14      = 0
-         jp_c140     = 0       
-      ENDIF
-      IF( ln_age    )  THEN      ! AGE
-         CALL trc_ini_age
-         jp_lc       = jp_lc + jp_age
-      ELSE
-         jp_age      = 0
-         jp_age0     = 0       
-      ENDIF
-      !
-      IF( jp_lc /= jptra ) THEN
-        IF( lwp ) WRITE(numout,*) ' The total number of tracers in namelist_top jptra = ', jptra
-        IF( lwp ) WRITE(numout,*) ' The total number of tracers to be used by the model is jp_lc = ', jp_lc
-        CALL ctl_stop( " Change the value of total number of tracers in namelist " )
-      ENDIF
+      !    
+      IF( ln_pisces  )   CALL trc_ini_pisces     !  PISCES model
+      IF( ln_my_trc  )   CALL trc_ini_my_trc     !  MY_TRC model
+      IF( ll_cfc     )   CALL trc_ini_cfc        !  CFC's
+      IF( ln_c14     )   CALL trc_ini_c14        !  C14 model
+      IF( ln_age     )   CALL trc_ini_age        !  AGE
       !
    END SUBROUTINE trc_ini_sms
@@ -247,5 +206,5 @@
 
       ! Initialisation of tracers Boundary Conditions
-      IF( lk_my_trc )     CALL trc_bc_init(jptra)
+      IF( ln_my_trc )     CALL trc_bc_init(jptra)
 
       IF( ln_rsttr ) THEN
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 7067)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 7068)
@@ -53,5 +53,6 @@
       !!---------------------------------------------------------------------
       INTEGER  ::   jn                  ! dummy loop indice
-      !                                  
+      !
+      IF( .NOT.lk_offline )   CALL trc_nam_run     ! Parameters of the run                                  
       !               
       CALL trc_nam_trc     ! passive tracer informations
@@ -111,10 +112,10 @@
       ENDIF
 
-      IF( lk_pisces  ) THEN   ;   CALL trc_nam_pisces      ! PISCES  bio-model
+      IF( ln_pisces  ) THEN   ;   CALL trc_nam_pisces      ! PISCES  bio-model
       ELSE                    ;   IF(lwp) WRITE(numout,*) '          PISCES not used'
       ENDIF
 
 
-      IF( lk_my_trc  ) THEN   ;   CALL trc_nam_my_trc      ! MY_TRC  tracers
+      IF( ln_my_trc  ) THEN   ;   CALL trc_nam_my_trc      ! MY_TRC  tracers
       ELSE                    ;   IF(lwp) WRITE(numout,*) '          MY_TRC not used'
       ENDIF
@@ -130,5 +131,5 @@
       !!
       !!---------------------------------------------------------------------
-      NAMELIST/namtrc_run/ jptra, nn_dttrc, ln_rsttr, nn_rsttr, ln_top_euler, &
+      NAMELIST/namtrc_run/ nn_dttrc, ln_rsttr, nn_rsttr, ln_top_euler, &
         &                  cn_trcrst_indir, cn_trcrst_outdir, cn_trcrst_in, cn_trcrst_out
       !
@@ -158,5 +159,4 @@
          WRITE(numout,*)
          WRITE(numout,*) ' Namelist : namtrc_run'
-         WRITE(numout,*) '   Total number of passive tracers              jptra         = ', jptra
          WRITE(numout,*) '   time step freq. for passive tracer           nn_dttrc      = ', nn_dttrc
          WRITE(numout,*) '   restart  for passive tracer                  ln_rsttr      = ', ln_rsttr
@@ -176,10 +176,12 @@
       !!
       !!---------------------------------------------------------------------
-      INTEGER  ::   ios, ierr                 ! Local integer output status for namelist read
+      INTEGER  ::   ios, ierr, ioptio, icfc     ! Local integer output status for namelist read
       INTEGER  ::   jn                    ! dummy loop indice
       !
       TYPE(PTRACER), DIMENSION(jpmaxtrc) :: sn_tracer  ! type of tracer for saving if not key_iomput
-      !!
-      NAMELIST/namtrc/ln_age, ln_cfc11, ln_cfc12, ln_c14, sn_tracer, ln_trcdta, ln_trcdmp, ln_trcdmp_clo
+      TYPE(STRACER), DIMENSION(jpmaxtrc) :: bc_tracer  ! type of tracer for saving if not key_iomput
+      !!
+      NAMELIST/namtrc/jptra, ln_pisces, ln_my_trc, ln_age, ln_cfc11, ln_cfc12, ln_c14, &
+         &            sn_tracer, ln_trcdta, ln_trcdmp, ln_trcdmp_clo
       !!---------------------------------------------------------------------
       IF(lwp) WRITE(numout,*)
@@ -197,35 +199,94 @@
       IF(lwm) WRITE ( numont, namtrc )
 
-
-      DO jn = 1, jptra
+      ioptio = 0
+      IF( ln_pisces )    ioptio = ioptio + 1
+      IF( ln_my_trc )    ioptio = ioptio + 1
+      !
+      IF( ioptio == 2 )   CALL ctl_stop( 'Choose only ONE BGC model - PISCES or MY_TRC' )
+      IF( ioptio == 0 )   jptra = 0
+
+      ll_cfc = ln_cfc11 .OR. ln_cfc12
+  
+      !
+      jp_pisces   =  0    ;   jp_pcs0  =  0    ;   jp_pcs1  = 0
+      jp_my_trc   =  0    ;   jp_myt0  =  0    ;   jp_myt1  = 0
+      jp_cfc      =  0    ;   jp_cfc0  =  0    ;   jp_cfc1  = 0
+      jp_age      =  0    ;   jp_c14   = 0
+      IF( ln_pisces )  THEN
+         jp_pisces = jptra
+         jp_pcs0   = 1
+         jp_pcs1   = jp_pisces
+      ENDIF
+      IF( ln_my_trc )  THEN
+          jp_my_trc = jptra
+          jp_myt0   = 1
+          jp_myt1   = jp_my_trc
+      ENDIF
+      !
+      jp_bgc  =   jptra
+      !
+      IF( ln_age )    THEN
+         jptra     = jptra + 1
+         jp_age    = jptra
+      ENDIF
+      IF( ln_cfc11 )  jp_cfc = jp_cfc + 1
+      IF( ln_cfc12 )  jp_cfc = jp_cfc + 1
+      IF( ll_cfc )    THEN
+          jptra     = jptra + jp_cfc
+          jp_cfc0   = jptra - jp_cfc + 1
+          jp_cfc1   = jptra
+      ENDIF
+      IF( ln_c14 )    THEN
+           jptra     = jptra + 1
+           jp_c14    = jptra
+      ENDIF
+
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : namtrc'
+         WRITE(numout,*) '   Total number of passive tracers              jptra         = ', jptra
+         WRITE(numout,*) '   Simulating PISCES model                      ln_pisces     = ', ln_pisces
+         WRITE(numout,*) '   Simulating water mass age                    ln_age        = ', ln_age
+         WRITE(numout,*) '   Simulating CFC11 passive tracer              ln_cfc11      = ', ln_cfc11
+         WRITE(numout,*) '   Simulating CFC12 passive tracer              ln_cfc12      = ', ln_cfc12
+         WRITE(numout,*) '   Simulating C14   passive tracer              ln_c14        = ', ln_c14
+         WRITE(numout,*) '   Simulating MY_TRC  model                     ln_my_trc     = ', ln_my_trc
+         WRITE(numout,*) '   Read inputs data from file (y/n)             ln_trcdta     = ', ln_trcdta
+         WRITE(numout,*) '   Damping of passive tracer (y/n)              ln_trcdmp     = ', ln_trcdmp
+         WRITE(numout,*) '   Restoring of tracer on closed seas           ln_trcdmp_clo = ', ln_trcdmp_clo
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' '
+      ENDIF
+      !
+      ALLOCATE( ctrcnm(jptra)      , ctrcln(jptra) , ctrcun(jptra)       , ln_trc_ini(jptra),          &
+#if defined key_bdy
+         &      cn_trc_dflt(nb_bdy), cn_trc(nb_bdy), nn_trcdmp_bdy(nb_bdy), trcdta_bdy(jptra,nb_bdy),  &
+#endif
+         &      ln_trc_sbc(jptra), ln_trc_cbc(jptra), ln_trc_obc(jptra), STAT = ierr  )
+      !
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'trc_nam_ice: unable to allocate arrays' )
+      !
+      DO jn = 1, jp_bgc
          ctrcnm    (jn) = TRIM( sn_tracer(jn)%clsname )
          ctrcln    (jn) = TRIM( sn_tracer(jn)%cllname )
          ctrcun    (jn) = TRIM( sn_tracer(jn)%clunit  )
          ln_trc_ini(jn) =       sn_tracer(jn)%llinit
-#if defined key_my_trc
-         ln_trc_sbc(jn) =       sn_tracer(jn)%llsbc
-         ln_trc_cbc(jn) =       sn_tracer(jn)%llcbc
-         ln_trc_obc(jn) =       sn_tracer(jn)%llobc
-#endif
       END DO
       !
-      ll_cfc = ln_cfc11 .OR. ln_cfc12
+      IF( ln_my_trc ) THEN
+         DO jn = 1, jp_bgc
+           ln_trc_sbc(jn) =  bc_tracer(jn)%llsbc
+           ln_trc_cbc(jn) =  bc_tracer(jn)%llcbc
+           ln_trc_obc(jn) =  bc_tracer(jn)%llobc
+         END DO
+      ENDIF
       !
       IF(lwp) THEN                   ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) ' Namelist : namtrc'
-         WRITE(numout,*) '   Simulating water mass age                    ln_age        = ', ln_age
-         WRITE(numout,*) '   Simulating CFC11 passive tracer              ln_cfc11      = ', ln_cfc11
-         WRITE(numout,*) '   Simulating CFC12 passive tracer              ln_cfc12      = ', ln_cfc12
-         WRITE(numout,*) '   Simulating C14   passive tracer              ln_c14        = ', ln_c14
-         WRITE(numout,*) '   Read inputs data from file (y/n)             ln_trcdta     = ', ln_trcdta
-         WRITE(numout,*) '   Damping of passive tracer (y/n)              ln_trcdmp     = ', ln_trcdmp
-         WRITE(numout,*) '   Restoring of tracer on closed seas           ln_trcdmp_clo = ', ln_trcdmp_clo
-         WRITE(numout,*) ' '
-         DO jn = 1, jptra
+         DO jn = 1, jp_bgc
             WRITE(numout,*) '  tracer nb : ', jn, '    short name : ', ctrcnm(jn)
          END DO
          WRITE(numout,*) ' '
       ENDIF
+      !
       !
       IF( ln_age .OR. ll_cfc .OR. ln_c14 ) THEN
@@ -252,5 +313,5 @@
       INTEGER :: ios, ierr     ! Local integer output status for namelist read
       !
-      TYPE(TRC_I_NML), ALLOCATABLE, DIMENSION(:) :: sn_tri_tracer  ! type of tracer for saving if not key_iomput
+      TYPE(TRC_I_NML), DIMENSION(jpmaxtrc) :: sn_tri_tracer  ! type of tracer for saving if not key_iomput
       !!
       NAMELIST/namtrc_ice/ nn_ice_tr, sn_tri_tracer
@@ -265,5 +326,4 @@
       IF( nn_timing == 1 )  CALL timing_start('trc_nam_ice')
 
-      ALLOCATE( sn_tri_tracer(jptra),  STAT = ierr )
       !
       REWIND( numnat_ref )              ! Namelist namtrc_ice in reference namelist : Passive tracer input data
@@ -281,7 +341,10 @@
       ENDIF
 
+      ALLOCATE( trc_ice_ratio(jptra), trc_ice_prescr(jptra), cn_trc_o(jptra), STAT = ierr  )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'trc_nam_ice: unable to allocate arrays' )
+      !
       ! Assign namelist stuff
       DO jn = 1, jptra
-         trc_ice_ratio(jn)  = sn_tri_tracer(jn)%trc_ratio
+         trc_ice_ratio (jn) = sn_tri_tracer(jn)%trc_ratio
          trc_ice_prescr(jn) = sn_tri_tracer(jn)%trc_prescr
          cn_trc_o      (jn) = sn_tri_tracer(jn)%ctrc_o
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcsms.F90	(revision 7067)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcsms.F90	(revision 7068)
@@ -49,9 +49,9 @@
       IF( nn_timing == 1 )   CALL timing_start('trc_sms')
       !
-      IF( lk_pisces  )   CALL trc_sms_pisces ( kt )    ! main program of PISCES 
+      IF( ln_pisces  )   CALL trc_sms_pisces ( kt )    ! main program of PISCES 
       IF( ll_cfc     )   CALL trc_sms_cfc    ( kt )    ! surface fluxes of CFC
       IF( ln_c14     )   CALL trc_sms_c14    ( kt )    ! surface fluxes of C14
       IF( ln_age     )   CALL trc_sms_age    ( kt )    ! Age tracer
-      IF( lk_my_trc  )   CALL trc_sms_my_trc ( kt )    ! MY_TRC  tracers
+      IF( ln_my_trc  )   CALL trc_sms_my_trc ( kt )    ! MY_TRC  tracers
 
       IF(ln_ctl) THEN      ! print mean trends (used for debugging)
Index: /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcwri.F90
===================================================================
--- /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcwri.F90	(revision 7067)
+++ /branches/2016/dev_r7012_ROBUST5_CNRS/NEMOGCM/NEMO/TOP_SRC/trcwri.F90	(revision 7068)
@@ -54,9 +54,9 @@
       ! write the tracer concentrations in the file
       ! ---------------------------------------
-      IF( lk_pisces  )   CALL trc_wri_pisces     ! PISCES 
+      IF( ln_pisces  )   CALL trc_wri_pisces     ! PISCES 
       IF( ll_cfc     )   CALL trc_wri_cfc        ! surface fluxes of CFC
       IF( ln_c14     )   CALL trc_wri_c14        ! surface fluxes of C14
       IF( ln_age     )   CALL trc_wri_age        ! AGE tracer
-      IF( lk_my_trc  )   CALL trc_wri_my_trc     ! MY_TRC  tracers
+      IF( ln_my_trc  )   CALL trc_wri_my_trc     ! MY_TRC  tracers
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_wri')
